Index: /trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java	(revision 4932)
@@ -601,37 +372,31 @@
 	    FileInputStream file = new FileInputStream(Utility.BASE_DIR + "classifiers.dat");
 	    ObjectInputStream input = new ObjectInputStream(file);
-	    reserve = (DynamicListModel) input.readObject();
+	    library = (ArrayList) input.readObject();
 	}
 	catch (Exception error) {
 	}
-	if(reserve == null) {
-	    reserve = new DynamicListModel();
-				// Retrieve the gsdl home directory...
-	    String directory = gatherer.config.gsdl_path;
+	if(library == null) {
+	    library = new ArrayList();
+	    // Retrieve the gsdl home directory...
+	    String directory = Gatherer.config.gsdl_path;
 	    directory = directory + "perllib" + File.separator + "classify" + File.separator;
-	    loadClassifiers(new File(directory));
-	}
-    }
-    /** Method to load plug-in information from a specified directory. Of course no plug-ins may be found at this location.
-	  * @param directory A <strong>File</strong> indicating the directory to be scanned for plug-ins.
-	  * @see org.greenstone.gatherer.cdm.ParsingProgress
-	  */
-    private void loadClassifiers(File directory) {
-	File files[] = directory.listFiles();
-	if(files != null) {
-	    // Create a progress indicator.
-	    ParsingProgress progress = new ParsingProgress(get("CDM.ClassifierManager.Parsing.Title"), get("CDM.ClassifierManager.Parsing.Message"), files.length);
-	    for(int i = 0; i < files.length; i++) {
-		// We only want to check Perl Modules.
-		if(files[i].getName().endsWith(".pm")) {
-		    loadClassifier(files[i]);
-		}
-		progress.inc();
-	    }
-	    progress.dispose();
-	    progress.destroy();
-	    progress = null;
-	}
-    }
+	    File files[] = (new File(directory)).listFiles();
+	    if(files != null) {
+		// Create a progress indicator.
+		ParsingProgress progress = new ParsingProgress(get("CDM.ClassifierManager.Parsing.Title"), get("CDM.ClassifierManager.Parsing.Message"), files.length);
+		for(int i = 0; i < files.length; i++) {
+		    // We only want to check Perl Modules.
+		    if(files[i].getName().endsWith(".pm")) {
+			loadClassifier(files[i]);
+		    }
+		    progress.inc();
+		}
+		progress.dispose();
+		progress.destroy();
+		progress = null;
+	    }
+	}
+    }
+
     /** Parses a DOM tree model turning it into a Classifier and its associated arguments.
 	  * @param root The <strong>Node</strong> at the root of the DOM model.
@@ -639,5 +404,5 @@
 	  * @see org.greenstone.gatherer.cdm.Argument
 	  */
-    private Classifier parse(Node root) {
+    private Classifier parseXML(Node root) {
 	Classifier classifier = new Classifier();
 	String node_name = null;
@@ -648,5 +413,5 @@
 		String name = MSMUtils.getValue(node);
 		// We can save ourselves some processing time if a classifier with this name already exists in our manager. If so retrieve it and return it.
-		Classifier existing = getClassifier(name);
+		Classifier existing = getBaseClassifier(name);
 		if(existing != null) {
 		    return existing;
@@ -655,5 +420,5 @@
 	    }
 	    else if(node_name.equals("Desc")) {
-		classifier.setDesc(MSMUtils.getValue(node));
+		classifier.setDescription(MSMUtils.getValue(node));
 	    }
 	    // Parse the multitude of arguments.
@@ -671,5 +436,5 @@
 			    }
 			    else if(node_name.equals("Desc")) {
-				argument.setDesc(MSMUtils.getValue(det));
+				argument.setDescription(MSMUtils.getValue(det));
 			    }
 			    else if(node_name.equals("Type")) {
@@ -677,5 +442,5 @@
 			    }
 			    else if(node_name.equals("Default")) {
-				argument.setDefault(MSMUtils.getValue(det));
+				argument.setDefaultValue(MSMUtils.getValue(det));
 			    }
 			    else if(node_name.equals("List")) {
@@ -713,5 +478,5 @@
 		    // A super classifier class.
 		    else if(node_name.equals("ClasInfo")) {
-			Classifier super_classifier = parse(arg);
+			Classifier super_classifier = parseXML(arg);
 			classifier.setSuper(super_classifier);
 		    }
@@ -726,14 +491,25 @@
     }
     /** A class which provides controls for assigned and editing classifiers. */
-    private class Control
-	extends JPanel {
+    private class ClassifierControl
+	extends JPanel 
+	implements Control {
+	/** A combobox containing all of the known classifiers, including those that may have already been assigned. */
+	private GComboBox classifier = null;
 	/** Button for adding classifiers. */
 	private JButton add = null;
 	/** Button for configuring the selected classifier. */
 	private JButton configure = null;
+
+	private JButton move_bottom_button;
+
+	private JButton move_down_button;
+
+	private JButton move_top_button;
+
+	private JButton move_up_button;
+
 	/** Button to remove the selected classifier. */
 	private JButton remove = null;
-	/** A combobox containing all of the known classifiers, including those that may have already been assigned. */
-	private JComboBox classifier = null;
+
 	/** A list of assigned classifiers. */
 	private JList classifier_list = null;
@@ -745,13 +521,6 @@
 	 * @see org.greenstone.gatherer.cdm.ClassifierManager.Control.RemoveListener
 	 */
-	public Control() {
-	    Object classifiers[] = reserve.toArray();
-	    ArrayList classifier_model = new ArrayList();
-	    for(int i = 0; i < classifiers.length; i++) {
-		classifier_model.add(((Classifier)classifiers[i]).getName());
-	    }
-	    // Now we add custom classifiers.
-	    addCustomClassifiers(classifier_model);
-	    Collections.sort(classifier_model);
+	public ClassifierControl() {
+	    Collections.sort(library);
 	    // Create
 	    add = new JButton(get("Add"));
@@ -766,8 +535,15 @@
 	    instructions.setRows(5);
 	    instructions.setWrapStyleWord(true);
-	    classifier = new JComboBox(classifier_model.toArray());
-	    classifier.setEditable(false);
+
+	    classifier = new GComboBox(library.toArray());
+	    classifier.setBackgroundNonSelectionColor(Gatherer.config.getColor("coloring.editable", false));
+	    classifier.setBackgroundSelectionColor(Gatherer.config.getColor("coloring.collection_selection_background", false));
+	    classifier.setEditable(true);
+	    classifier.setSelectedIndex(0);
+	    classifier.setTextNonSelectionColor(Gatherer.config.getColor("coloring.workspace_tree_foreground", false));
+	    classifier.setTextSelectionColor(Gatherer.config.getColor("coloring.collection_selection_foreground", false));
+
 	    JLabel classifier_label = new JLabel(get("Classifier"));
-	    classifier_list = new JList(assigned);
+	    classifier_list = new JList(model);
 	    classifier_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
 	    JLabel classifier_list_label = new JLabel(get("Assigned"));
@@ -782,4 +558,51 @@
 	    title.setOpaque(true);
 	    JPanel temp = new JPanel(new BorderLayout());
+
+	    JPanel move_button_pane = new JPanel();
+
+	    move_bottom_button = new JButton();
+	    JLabel move_bottom_label = new JLabel(get("CDM.Move.Move_Bottom"));
+	    move_bottom_label.setHorizontalAlignment(JLabel.CENTER);
+	    move_bottom_label.setPreferredSize(LABEL_SIZE);
+	    ImageIcon move_bottom_icon = Utility.getImage("arrow-bottom.gif");
+	    move_bottom_button.setLayout(new BorderLayout());
+	    move_bottom_button.add(new JLabel(move_bottom_icon), BorderLayout.WEST);
+	    move_bottom_button.add(move_bottom_label, BorderLayout.CENTER);
+	    move_bottom_button.add(new JLabel(move_bottom_icon), BorderLayout.EAST);
+	    move_bottom_button.setMnemonic(KeyEvent.VK_B);
+
+	    move_down_button = new JButton();
+	    JLabel move_down_label = new JLabel(get("CDM.Move.Move_Down"));
+	    move_down_label.setHorizontalAlignment(JLabel.CENTER);
+	    move_down_label.setPreferredSize(LABEL_SIZE);
+	    ImageIcon move_down_icon = Utility.getImage("arrow-down.gif");
+	    move_down_button.setLayout(new BorderLayout());
+	    move_down_button.add(new JLabel(move_down_icon), BorderLayout.WEST);
+	    move_down_button.add(move_down_label, BorderLayout.CENTER);
+	    move_down_button.add(new JLabel(move_down_icon), BorderLayout.EAST);
+	    move_down_button.setMnemonic(KeyEvent.VK_D);
+
+	    move_top_button = new JButton();
+	    JLabel move_top_label = new JLabel(get("CDM.Move.Move_Top"));
+	    move_top_label.setHorizontalAlignment(JLabel.CENTER);
+	    move_top_label.setPreferredSize(LABEL_SIZE);
+	    ImageIcon move_top_icon = Utility.getImage("arrow-top.gif");
+	    move_top_button.setLayout(new BorderLayout());
+	    move_top_button.add(new JLabel(move_top_icon), BorderLayout.WEST);
+	    move_top_button.add(move_top_label, BorderLayout.CENTER);
+	    move_top_button.add(new JLabel(move_top_icon), BorderLayout.EAST);
+	    move_top_button.setMnemonic(KeyEvent.VK_T);
+
+	    move_up_button = new JButton();
+	    JLabel move_up_label = new JLabel(get("CDM.Move.Move_Up"));
+	    move_up_label.setHorizontalAlignment(JLabel.CENTER);
+	    move_up_label.setPreferredSize(LABEL_SIZE);
+	    ImageIcon move_up_icon = Utility.getImage("arrow-up.gif");
+	    move_up_button.setLayout(new BorderLayout());
+	    move_up_button.add(new JLabel(move_up_icon), BorderLayout.WEST);
+	    move_up_button.add(move_up_label, BorderLayout.CENTER);
+	    move_up_button.add(new JLabel(move_up_icon), BorderLayout.EAST);
+	    move_up_button.setMnemonic(KeyEvent.VK_U);
+
 	    // Listeners
 	    add.addActionListener(new AddListener());
@@ -788,30 +611,53 @@
 	    classifier_list.addMouseListener(new ClickListener());
 	    classifier_list.addListSelectionListener(new ListListener());
+
+	    MoveListener ml = new MoveListener();
+	    move_bottom_button.addActionListener(ml);
+	    move_down_button.addActionListener(ml);
+	    move_top_button.addActionListener(ml);
+	    move_up_button.addActionListener(ml);
 	    // Layout
 	    title.setBorder(BorderFactory.createEmptyBorder(0,0,2,0));
+
 	    instructions.setBorder(BorderFactory.createEmptyBorder(2,5,2,5));
+
 	    header_pane.setLayout(new BorderLayout());
 	    header_pane.add(title, BorderLayout.NORTH);
 	    header_pane.add(new JScrollPane(instructions), BorderLayout.CENTER);
+
+	    move_button_pane.setLayout(new GridLayout(4,1));
+	    move_button_pane.add(move_top_button);
+	    move_button_pane.add(move_up_button);
+	    move_button_pane.add(move_down_button);
+	    move_button_pane.add(move_bottom_button);
+
 	    classifier_list_label.setBorder(BorderFactory.createEmptyBorder(0,2,0,2));
+
 	    classifier_list_pane.setLayout(new BorderLayout());
 	    classifier_list_pane.add(classifier_list_label, BorderLayout.NORTH);
 	    classifier_list_pane.add(new JScrollPane(classifier_list), BorderLayout.CENTER);
+	    classifier_list_pane.add(move_button_pane, BorderLayout.EAST);
+
 	    classifier_label.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));
+
 	    classifier_pane.setBorder(BorderFactory.createEmptyBorder(5,0,5,0));
 	    classifier_pane.setLayout(new GridLayout(1,2));
 	    classifier_pane.add(classifier_label);
 	    classifier_pane.add(classifier);
+
 	    button_pane.setLayout(new GridLayout(3,1));
 	    button_pane.add(add);
 	    button_pane.add(configure);
 	    button_pane.add(remove);
+
 	    // Scope these mad bordering skillz.
 	    temp.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(5,0,5,0), BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(get("Controls")), BorderFactory.createEmptyBorder(2,2,2,2))));
 	    temp.add(classifier_pane, BorderLayout.NORTH);
 	    temp.add(button_pane, BorderLayout.SOUTH);
+
 	    central_pane.setLayout(new BorderLayout());
 	    central_pane.add(classifier_list_pane, BorderLayout.CENTER);
 	    central_pane.add(temp, BorderLayout.SOUTH);
+
 	    setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
 	    setLayout(new BorderLayout());
@@ -831,55 +677,15 @@
 	/** This method is overridden to ensure the instructions are scrolled to top, before the super classes updateUI() is called.
 			*/
-	public void updateUI() {
+	public void gainFocus() {
 	    if(instructions != null) {
 		instructions.setCaretPosition(0);
 	    }
-	    super.updateUI();
-	}
-	/** Searches and adds a list of dynamically located CustomClassifiers. Note that the classes must be located under org.greenstone.gatherer.cdm.custom and have accompaning properties files which are used as dictionaries.
-			* @param classifier_model An <strong>ArrayList</strong> which will be used as the model for the combobox listing all known Classifiers.
-			*/
-	private void addCustomClassifiers(ArrayList classifier_model) {
-	    //classifier_model.add("CustomAZList");
-	    // Search for classifiers under the org.greenstone.gatherer.cdm.custom directory.
-	    File custom_directory = new File(Utility.BASE_DIR + "classes" + File.separator + "org" + File.separator + "greenstone" + File.separator + "gatherer" + File.separator + "cdm" + File.separator + "custom");
-	    if(custom_directory.exists()) {
-		File children[] = custom_directory.listFiles();
-		for(int i = 0; i < children.length; i++) {
-		    String temp = children[i].getName().toLowerCase();
-		    // There are a whole bunch of conditions about what files are custom classifier main classes.
-		    if(temp.endsWith(".class") && temp.indexOf("$") == -1) {
-			// Determine the name of this custom classifier.
-			String name = children[i].getName();
-			name = name.substring(0, name.indexOf("."));
-			classifier_model.add(name);
-		    }
-		}
-	    }
-	    // Search for any other CustomClassifiers within the jar file (if present)
-	    File jar_file = new File(Utility.GLI_ARCHIVE);
-	    if(jar_file.exists()) {
-		try {
-		    JarFile jar = new JarFile(jar_file);
-		    for(Enumeration entries = jar.entries(); entries.hasMoreElements(); ) {
-			String name = entries.nextElement().toString();
-			if(name.startsWith("org/greenstone/gatherer/cdm/custom/") && name.endsWith(".class") && name.indexOf("$") == -1) {
-			    name = name.substring(35, name.length() - 6);
-			    if(!classifier_model.contains(name)) {
-				classifier_model.add(name);
-			    }
-			}
-			name = null;
-		    }
-		    jar = null;
-		}
-		catch (Exception error) {
-		    error.printStackTrace();
-		}
-	    }
-	    jar_file = null;
-	}
+	}
+
+	public void loseFocus() {
+	}
+
 	/** This class listens for actions upon the add button in the controls, and if detected calls the assignClassifier() method.
-			*/
+	 */
 	private class AddListener
 	    implements ActionListener {
@@ -892,42 +698,38 @@
 	     */
 	    public void actionPerformed(ActionEvent event) {
-		String name = (String)classifier.getSelectedItem();
-		Classifier target = getClassifier(name);
-		Classifier classifier = null;
-		CustomClassifier custom_classifier = null;
-		if(target != null) {
-		    classifier = target.copy();
-		}
-		else {
-		    // Try to retrieve custom classifier for name.
-		    try {
-			Class custom_class = Class.forName("org.greenstone.gatherer.cdm.custom." + name);
-			custom_classifier = (CustomClassifier)custom_class.newInstance();
-			custom_classifier.setGatherer(gatherer);
-		    }
-		    catch (Exception error) {
-			Gatherer.println("Error in ClassifierManager.AddListener.actionPerformed(): " + error);
-			Gatherer.printStackTrace(error);
-			
-		    }
-		    // And if all else fails create a new classifier.
-		    if(classifier == null && custom_classifier == null) {
-			classifier = new Classifier(name, "", null);
-		    }
-		}
-		if(classifier != null) {
+		Object selected_object = classifier.getSelectedItem();
+		// If there is something in the combobox, but we haven't registered a selection, then add the object and select it!
+		if(selected_object != null && classifier.getSelectedIndex() == -1) {
+		    classifier.insertItemAt(selected_object, classifier.getItemCount());
+		}
+		if(selected_object != null) {
+		    // Create a new element in the DOM
+		    Element element = CollectionDesignManager.collect_config.document.createElement(CollectionConfiguration.CLASSIFY_ELEMENT);
+		    Classifier new_classifier = null;
+		    if(selected_object instanceof Classifier) {
+			Classifier base_classifier = (Classifier) selected_object;
+			element.setAttribute(CollectionConfiguration.TYPE_ATTRIBUTE, base_classifier.getName());
+			new_classifier = new Classifier(element, base_classifier);
+			base_classifier = null;
+		    }
+		    else {
+			element.setAttribute(CollectionConfiguration.TYPE_ATTRIBUTE, selected_object.toString());
+			new_classifier = new Classifier(element, null);
+		    }
+		    element = null;
 		    // Automatically chain to configuration. This ensures required arguments are filled out.
-		    ArgumentConfiguration ac = new ArgumentConfiguration(gatherer, manager, classifier);
+		    ArgumentConfiguration ac = new ArgumentConfiguration(new_classifier);
 		    if(ac.display()) {
-			assignClassifier(classifier);
-		    }
-		    ac.destroy();
+			if(!model.contains(new_classifier)) {
+			    assignClassifier(new_classifier);
+			    classifier_list.setSelectedValue(new_classifier, true);
+			}
+			else {
+			    JOptionPane.showMessageDialog(Gatherer.g_man, get("Classifier_Exists"), get("General.Error"), JOptionPane.ERROR_MESSAGE);
+			}
+		    }
 		    ac = null;
-		}
-		// Custom classifier
-		else {
-		    // Spawn a new thread to handle this, as custom_classifiers can be processor heavy.
-		    CustomClassifierTask task = new CustomClassifierTask(custom_classifier);
-		    task.start();
+		    new_classifier = null;
+		    classifier.setSelectedIndex(0);
 		}
 	    }
@@ -936,27 +738,17 @@
 	private class ClickListener
 	    extends MouseAdapter {
-				/** Called whenever the mouse is clicked over a registered component, we use this to chain through to the configure prompt.
-				 * @param event A <strong>MouseEvent</strong> containing information about the mouse click.
-				 */
+	    /** Called whenever the mouse is clicked over a registered component, we use this to chain through to the configure prompt.
+	     * @param event A <strong>MouseEvent</strong> containing information about the mouse click.
+	     */
 	    public void mouseClicked(MouseEvent event) {
 		if(event.getClickCount() == 2 ) {
 		    if(!classifier_list.isSelectionEmpty()) {
-			Object object = classifier_list.getSelectedValue();
-			if(object instanceof Classifier) {
-			    ArgumentConfiguration ac = new ArgumentConfiguration(gatherer, manager, (Classifier)object);
-			    if(ac.display()) {
-				assigned.refresh();
-			    }
-			    ac.destroy();
-			    ac = null;
+			Classifier classifier = (Classifier) classifier_list.getSelectedValue();
+			ArgumentConfiguration ac = new ArgumentConfiguration(classifier);
+			if(ac.display()) {
+			    refresh(classifier);
 			}
-			else if(object instanceof CustomClassifier) {
-			    CustomClassifier cc = (CustomClassifier)object;
-			    if(cc.display(true)) {
-				assigned.refresh();
-			    }
-			    cc.hide(); // Remove gui prompt or else.
-			    cc = null;
-			}
+			ac.destroy();
+			ac = null;
 		    }
 		}
@@ -975,40 +767,12 @@
 	    public void actionPerformed(ActionEvent event) {
 		if(!classifier_list.isSelectionEmpty()) {
-		    Object object = classifier_list.getSelectedValue();
-		    if(object instanceof Classifier) {
-			ArgumentConfiguration ac = new ArgumentConfiguration(gatherer, manager, (Classifier)object);
-			if(ac.display()) {
-			    assigned.refresh();
-			}
-			ac.destroy();
-			ac = null;
-		    }
-		    else if(object instanceof CustomClassifier) {
-			CustomClassifier cc = (CustomClassifier)object;
-			if(cc.display(true)) {
-			    assigned.refresh();
-			}
-			cc.hide(); // Remove gui prompt or else.
-			cc = null;
-		    }
-		}
-	    }
-	}
-
-	private class CustomClassifierTask
-	    extends Thread {
-
-	    private CustomClassifier custom_classifier;
-
-	    CustomClassifierTask(CustomClassifier custom_classifier) {
-		this.custom_classifier = custom_classifier;
-	    }
-
-	    public void run() {
-		if(custom_classifier.display(true)) {
-		    assignClassifier(custom_classifier);
-		}
-		custom_classifier.hide(); // Remove gui prompt or else.
-		custom_classifier = null;
+		   Classifier classifier = (Classifier) classifier_list.getSelectedValue();
+		   ArgumentConfiguration ac = new ArgumentConfiguration(classifier);
+		   if(ac.display()) {
+		       refresh(classifier);
+		   }
+		   ac.destroy();
+		   ac = null; 
+		}
 	    }
 	}
@@ -1030,4 +794,34 @@
 	    }
 	}
+
+	/** Listens for actions apon the move buttons in the manager controls, and if detected calls the <i>moveClassifier()</i> method of the manager with the appropriate details. */
+	private class MoveListener
+	    implements ActionListener {
+	    /** Any implementation of <i>ActionListener</i> must include this method so that we can be informed when an action has occured on one of our target controls.
+	     * @param event An <strong>ActionEvent</strong> containing information garnered from the control action.
+	     */
+	    public void actionPerformed(ActionEvent event) {
+		if(!classifier_list.isSelectionEmpty()) {
+		    Object object = classifier_list.getSelectedValue();
+		    if(object instanceof Classifier) {
+			Classifier classifier = (Classifier) object;
+			if(event.getSource() == move_top_button) {
+			    moveClassifier(classifier, true, true);
+			}
+			else if(event.getSource() == move_up_button) {
+			    moveClassifier(classifier, true, false);
+			}
+			else if(event.getSource() == move_down_button) {
+			    moveClassifier(classifier, false, false);
+			}
+			else {
+			    moveClassifier(classifier, false, true);
+			}
+			classifier_list.setSelectedValue(classifier, true);
+		    }
+		}
+	    }
+	}
+
 	/** This class listens for actions upon the remove button in the controls, and if detected calls the removeClassifier() method.
 			*/
@@ -1041,7 +835,9 @@
 	    public void actionPerformed(ActionEvent event) {
 		if(!classifier_list.isSelectionEmpty()) {
-		    Object object = classifier_list.getSelectedValue();
-		    if(object instanceof Classifier || object instanceof CustomClassifier) {
-			removeClassifier(object);
+		    Object [] objects = classifier_list.getSelectedValues();
+		    for(int i = 0; i < objects.length; i++) {
+			if(objects[i] instanceof Classifier) {
+			    removeClassifier((Classifier)objects[i]);
+			}
 		    }
 		}
@@ -1050,8 +846,2 @@
     }
 }
-
-
-
-
-
-
